//
//  ViewController.swift
//  demo13-使用UIDatePicker实现倒计时功能
//
//  Created by zero on 16/12/27.
//  Copyright © 2016年 yunhaitechnology. All rights reserved.
//
//有想一起探讨swift的请加微信R1301445574
import UIKit

class ViewController: UIViewController {
    //有想一起探讨swift的请加微信R1301445574
    var ctimer:UIDatePicker!
    var btnStart:UIButton!
    var leftTime:Int = 60
    var alertController:UIAlertController!
    var timer:Timer!
    override func viewDidLoad() {
        super.viewDidLoad()
        ctimer = UIDatePicker(frame:CGRect(x:0, y:120, width:200, height:200))
        self.ctimer.datePickerMode = UIDatePickerMode.countDownTimer
        //必须为 60 的整数倍，比如设置为100，值自动变为 60
        DispatchQueue.main.async{
            self.ctimer.countDownDuration = TimeInterval(self.leftTime)
        }
        
        ctimer.addTarget(self, action: #selector(timerChanged), for: .valueChanged)
        self.view.addSubview(ctimer)
        btnStart = UIButton(type:.system)
        btnStart.frame = CGRect(x:100, y:400, width:100, height:100)
        btnStart.setTitleColor(UIColor.red, for: .normal)
        btnStart.setTitleColor(UIColor.green, for: .disabled)
        btnStart.setTitle("开始", for: .normal)
        btnStart.setTitle("倒计时中", for: .disabled)
        btnStart.clipsToBounds = true
        btnStart.layer.cornerRadius = 5
        btnStart.addTarget(self, action: #selector(startClicked(sender:)), for: .touchUpInside)
        self.view.addSubview(btnStart)
    }
    
    func timerChanged() {
        print("您选择倒计时间为：\(self.ctimer.countDownDuration)")
    }
    //倒计时按钮点击
    func startClicked(sender:UIButton) {
        self.btnStart.isEnabled = false
        //获取倒计时器的剩余时间
        leftTime = Int(self.ctimer.countDownDuration)
        //禁用UIDatePicker控件和按钮
        self.ctimer.isEnabled = false
        // 创建一个UIAlertController对象（警告框），并确认，倒计时开始
        alertController = UIAlertController(title: "系统提示",
                                            message: "倒计时开始，还有 \(leftTime) 秒...",
            preferredStyle: .alert)
        let cancelAction = UIAlertAction(title:"确定",style:.cancel,handler:nil)
        alertController.addAction(cancelAction)
        //显示UIAlertController组件
        self.present(alertController, animated: true, completion: nil)
        //启用计时器，控制每秒执行一次tickDown方法
        timer = Timer.scheduledTimer(timeInterval: TimeInterval(1), target: self, selector: #selector(tickDown), userInfo: nil, repeats: true)
    }
    /**
     *计时器每秒触发事件
     **/
    func tickDown() {
        alertController.message = "倒计时开始，还有 \(leftTime) 秒..."
        // 将剩余时间减少1秒
        leftTime -= 1
        // 修改UIDatePicker的剩余时间
        self.ctimer.countDownDuration = TimeInterval(leftTime)
        if leftTime <= 0 {
            //取消定时器
            timer.invalidate();
            //启用UIDatePicker控件和按钮
            self.ctimer.isEnabled = true
            self.btnStart.isEnabled = true
            alertController.message = "时间到"
        }
    }
}

